import { CellOptions } from '@difizen/libro-core';
import { ManaModule } from '@difizen/mana-app';
import { RawCellContribution } from "./raw-cell-contribution.js";
import { LibroRawCellModel } from "./raw-cell-model.js";
import { RawCellModelFactory } from "./raw-cell-protocol.js";
import { LibroRawCellView } from "./raw-cell-view.js";
export var RawCellModule = ManaModule.create().register(RawCellContribution, LibroRawCellView, LibroRawCellModel, {
  token: RawCellModelFactory,
  useFactory: function useFactory(ctx) {
    return function (options) {
      var child = ctx.container.createChild();
      child.register({
        token: CellOptions,
        useValue: options
      });
      var model = child.get(LibroRawCellModel);
      return model;
    };
  }
});