import type { IRange } from '@difizen/libro-code-editor';
import { CodeEditorView } from '@difizen/libro-code-editor';
import type { CellViewOptions } from '@difizen/libro-core';
import { CellService, LibroEditorCellView } from '@difizen/libro-core';
import { ViewManager } from '@difizen/mana-app';
import { Deferred } from '@difizen/mana-app';
import React from 'react';
import type { LibroRawCellModel } from './raw-cell-model.js';
export declare class LibroRawCellView extends LibroEditorCellView {
    model: LibroRawCellModel;
    view: React.ForwardRefExoticComponent<React.RefAttributes<HTMLDivElement>>;
    viewManager: ViewManager;
    editorView?: CodeEditorView;
    protected editorViewReadyDeferred: Deferred<void>;
    get editorReady(): Promise<void>;
    constructor(options: CellViewOptions, cellService: CellService, viewManager: ViewManager);
    onViewMount(): void;
    createEditor(): void;
    shouldEnterEditorMode(e: React.FocusEvent<HTMLElement>): boolean;
    blur: () => void;
    focus: (toEdit: boolean) => void;
    getSelections: () => [];
    getSelectionsOffsetAt: (selection: IRange) => {
        start: number;
        end: number;
    };
}
//# sourceMappingURL=raw-cell-view.d.ts.map